from MarcoUtil import *

# H : hatrack
# E : easel
# Y : Yellow type road
# G : grassy hallway
# C : Chair
# B : Butterfly
# S : Sofa
# W : Wooden road.
# L : lamp


N = 0;
M = 0;


def to_lower(s):
	sz = len(s);
	for i in range(0 , sz):
		if (s[i] >= 'A' and s[i] <= 'Z'):
			s[i] = s[i] - 'A' + 'a';
	return s;

def return_object(s , i):
	if (len(s) == 0):
		return 'None';
	else:
		if (s[i] == 'hatrack'):
			return 'H';
		
		elif (s[i] == 'easel'):
			return 'E';
		
		elif ((s[i] == 'honey' and s[i + 1] == 'comb') or (s[i] == 'honey comb')):
			return 'Y';
		
		elif (s[i] == 'chair'):
			return 'C';
		
		elif (s[i] == 'sofa'):
			return 'S';
		
		elif (s[i] == 'wood'):
			return 'W';

		elif (s[i] == 'butterfly'):
			return 'B';

		elif (s[i] == 'lamp'):
			return 'L';

		elif (s[i] == 'grass'):
			return 'G';

	return 'None';

# check scent in case of yellow
# test of honey comb 		

def check_turning(s,pos):
	turn_occured = 0;
	direction_occured = 0;
	turn = 'None';
	done = 0;
	for i in range(pos , len(s)):
		if (s[i] == 'turn'):
			turn_occured = 1;
			if (done):
				break;
			for j in range(i , len(s)):
				if (s[i] == 'left' or s[i] == 'right'):
					direction_occured = true;
					turn = s[i];
					done = 1;
					break;

	return turn;

def isInt(s):
	sz = len(s);
	if (sz == 0):
		return 0;
	for i in range (0 , sz):
		if (s[i] >= '0' and s[i] <= '9'):
			continue;
		else:
			return 0;
	return 1;

def check_times(s , pos):
	sz = len(s);
	count_occured = 0;
	value_occured = 1;
	done = 0;
	value = 0;
	for i in range (pos , sz):
		if (s[i] == 'count'):
			count_occured = 1;
			if (done):
				break;
			for j in range (i , sz):
				if (isInt(s[i])):
					value = int (s[i]);
					value_occured = 1;
					done = 1;
					break;	
	if (done):
		return value;
	return 'None';

def has_travel(s,pos):
	travel_occured = 0;
	sz = len(s);
	for i in range(pos , sz):
		if (s[i] == 'travel'):
			return 1;
	return 0;

def check_attribute_values(s, pos):
	sz = len(s);
	for i in range(pos , sz):
		if (s[i] == 'value'):
			if (i + 2 < sz and s[i + 2] == 'intersection'):
				return 'intersection';
	return 'None';

def check_attirbute_types(s, pos):
	sz = len(s);
	for i in range(pos , sz):
		if (s[i] == 'type'):
			if (s[i + 1] == 'pathdir'):
				return 'pathdir';
	return 'None';

### check if it is valid to move
def isValid (x , y):
	if (x >= 0 and x <= len(grid) and y >= 0 and len(grid[0])):
		return 1;
	return 0;


# do not forget to make all the words small sized alphabets.

myDir['N'] = 0
myDir['S'] = 180
myDir['E'] = 90
myDir['W'] = 270


def get_direction(direction):
	if (direction == 0):
		return 'N';
	elif (direction == 90):
		return 'E';
	elif (direction == 180):
		return 'S';
	elif (direction == 270):
		return 'W';
	else:
		return 'random';

def turn_me(x , y, direction , where):
	if (where == 'left'):
		dr = get_direction(where);
		ndr = 'N';
		if (dr == 'N'):
			ndr = 'W';
		elif (dr == 'S'):
			ndr = 'E';
		elif (dr == 'E'):
			ndr = 'N';
		elif (dr == 'W'):
			ndr = 'S';

		return (x , y , myDir[ndr]);
	else if (where == 'right'):
		dr = get_direction(where);
		ndr = 'N';
		if (dr == 'N'):
			ndr = 'E';
		elif (dr == 'S'):
			ndr = 'W';
		elif (dr == 'E'):
			ndr = 'S';
		elif (dr == 'W'):
			ndr = 'N';

		return (x , y , myDir[ndr]);
	else:
		return (x , y , 0);


def main():

	print 'enter the instruction to parse';
	instruction = raw_input()

	actions = parse(instruction)

	print actions

	grid=[
	    '############',
	    '#..H....####',
	    '#.#.#.#B#..#',
	    '#YYYYYYY##C#',
	    '#C#.#.#W####',
	    '#G...L.W#.##',
	    '#G#.###W#.##',
	    '#GG....W..##',
	    '#.#.#WWWW..#',
	    '#..H..#W##H#',
	    '#.#.#.##S###',
	    '#GGGGG#.#..#',
	    '#.###.#.S.##',
	    '############',
	    ]

	global N;
	global M;

	N = len(grid);
	M = len(grid[0]);

	# H : hatrack
	# E : easel
	# Y : Yellow type road
	# G : grassy hallway
	# C : Chair
	# B : Butterfly
	# S : Sofa1
	# W : Wooden road.
	# L : lamp


	words = [];

	data = "";

	actions = str(actions);

	print type(actions);	

	print actions;
	print len (actions);
	for i in range(0 , len(actions)):
		if (actions[i] == '=' or actions[i] == ' ' or actions[i] == ',' or actions[i] == '<' or actions[i] == '>' or actions[i] == '[' or actions[i] == ']' or actions[i] == '(' or actions[i] == ')'):
			if (len(data)):
				words.append(data);
			print 'hi' , actions[i] , data;
			data = "";
		else:
			print 'bye'
			data = data + actions[i];

	print 'heeeeeeere';
	print len(words);
	for i in range (0 , len(words)):
		print words[i]


	
	x = start_x;
	y = start_y;
	direction = start_direction;

	i = 0;
	while (i < len(s)):
		incremented = 0;

		res = check_turning(s , i);
		if (res == 'left'):
			a , b , c = turn_me(x , y , direction , 'left');
			x = a;
			y = b;
			direction = c;
			continue;
		elif (res == 'right'):
			turn_me(x , y , direction , 'right');

		## check how many times to move
		res = check_times(s , i);
		if (res != 'None' and res != 0):
			move_further(x , y , direction , res);

		res = return_object(s , i);
		
		# there might some probability of error here.
		# look into the matter.

		error_chances = 0;

		if (grid[x][y] != res):
			error_chances += 1;
		
		for i in range (0 , 10):
			for i in range (4):

		# try moving until you reach the object 
		nx = x;
		ny = y;
		ndir = direction;
		if (res != 'None'):	
			dr = get_direction(direction);
			if (not isValid(nx , ny)):
				continue;
			
			# if you find a object in that direction , change your coordinate there and go there.
			if (s[nx][ny] == res):
				x = nx;
				y = ny;
				direction = myDir[res];
				continue;

			if (dr == 'N'):
				nx -= 1;
			elif (dr == 'S'):
				nx += 1;
			elif (dr == 'E'):
				ny += 1;
			elif (dr == 'W'):
				ny -= 1; 

		# check by going to perticular position.
		# Now you need to go to that position.
		
		if (!incremented):
			i = i + 1;

if __name__ == '__main__':
	main();