from Tkinter import *
import math
from MarcoUtil import *;
import time

class gui:
	def has_error(self,s):
		sz = len(s);
		if (sz == 0):
			return 1;
		if (s[0] == 'U' and s[0] == 'n'):
			return 1;
		return 0;

	def give_coordinates(self,s):
		actions = parse(s);
		# print the output to seeing parse
		
		
		res = execute ("jelly" , (self.start_x , self.start_y , self.start_direction) , actions);
		print res;
		if (self.has_error(res)):
			return [];
		else:
			return res;
		
	def __init__(self):
		self.start_x = 18;
		self.start_y = 16;
		self.start_direction = 0;
		
		root = Tk()
		root.title('Cognetive Science Project : Learning to parse Natural Language Instruction in Navigation')
		
		self.canvas = Canvas(root, width=420, height=600, bg = 'white')
		self.canvas.bind("<Button-1>", self.move)
		self.canvas.pack()
		
		photo = PhotoImage(file="Map_new.gif")	
		item = self.canvas.create_image(0, 0, anchor=NW, image=photo)
		
		self.linex = 90
		self.liney = 330
		self.angle = 0
		self.createPolygon(90,330,0)
		
		self.xframe = Frame(root)
		self.xlabel = Label(self.xframe)
		self.xlabel["text"]="User Input"
		self.xlabel.pack(side=LEFT)
		self.xentry = Entry(self.xframe,width="100")
		self.xentry.pack(side=LEFT)
		self.xentry.focus_set()
		self.xframe.pack()
		
		
		b = Button(root, text="Submit", width=10, command=self.callback)
		b.pack()
		
		root.mainloop()
	
	def createPolygon(self,x,y,angle):
		length = 10
		length1 = 20
		angle = angle - 90
		self.angle = angle
		x0 = x + length1 * math.cos(math.radians(angle))
		y0 = y + length1 * math.sin(math.radians(angle))
		x1 = x + length * math.cos(math.radians(angle+120))
		y1 = y + length * math.sin(math.radians(angle+120))
		x2 = x + length * math.cos(math.radians(angle+240))
		y2 = y + length * math.sin(math.radians(angle+240))
		self.myPolygon = self.canvas.create_polygon((x0,y0,x1,y1,x2,y2),fill="blue")
	
	def movePolygon(self,x,y,angle):
		length = 10
		length1 = 20
		angle = angle - 90
		self.angle = angle
		x0 = x + length1 * math.cos(math.radians(angle))
		y0 = y + length1 * math.sin(math.radians(angle))
		x1 = x + length * math.cos(math.radians(angle+120))
		y1 = y + length * math.sin(math.radians(angle+120))
		x2 = x + length * math.cos(math.radians(angle+240))
		y2 = y + length * math.sin(math.radians(angle+240))
		self.canvas.coords(self.myPolygon,x0,y0,x1,y1,x2,y2)
		
	def move(self,x,y,angle):
		x = x * 60 + 30
		y = y * 60 + 30
		self.canvas.create_line(self.linex,self.liney,x,y)
		self.linex = x
		self.liney = y
		self.movePolygon(self.linex,self.liney,angle)
	
	def callback(self):
		res = self.give_coordinates(self.xentry.get())
		
		# need to take care of x and y
		for (y , x , angle) in res:
			print x-15
			print 23-y
			self.move(x-15 , 23-y ,angle-self.angle);
			self.start_x = y
			self.start_y = x
			self.start_direction = angle
		
x = gui()
