from Tkinter import *
import math
from MarcoUtil import *;

class gui:
	def has_error(s):
		sz = len(s);
		if (sz == 0):
			return 1;
		if (s[0] == 'U' and s[0] == 'n'):
			return 1;
		return 0;

	def give_coordinates():
		s = 'turn left and move forward';
		actions = parse("turn left");
		# print the output to seeing parse
		start_x = 0;
		start_y = 0;
		start_direction = 0;
		
		res = execute ("jelly" , (startx , starty , start_direction) , s);
		
		

	def __init__(self):
		root = Tk()
		root.title('Cognetive Science Project : Learning to parse Natural Language Instruction in Navigation')
		
		self.canvas = Canvas(root, width=450, height=300, bg = 'white')
		self.canvas.bind("<Button-1>", self.move)
		self.canvas.pack()
		
		#photo = PhotoImage(file="/home/bhanu/pic.gif")
		#item = self.canvas.create_image(0, 0, anchor=NW, image=photo)
		
		self.linex = 0
		self.liney = 0
		
		self.createPolygon(0,0,0)
		
		self.xframe = Frame(root)
		self.xlabel = Label(self.xframe)
		self.xlabel["text"]="X Coordinate"
		self.xlabel.pack(side=LEFT)
		self.xentry = Entry(self.xframe)
		self.xentry.pack(side=LEFT)
		self.xentry.focus_set()
		self.xframe.pack()
		
		self.yframe = Frame(root)
		self.ylabel = Label(self.xframe)
		self.ylabel["text"]="Y Coordinate"
		self.ylabel.pack(side=LEFT)
		self.yentry = Entry(self.xframe)
		self.yentry.pack(side=LEFT)
		self.yframe.pack()
		
		self.aframe = Frame(root)
		self.alabel = Label(self.xframe)
		self.alabel["text"]="Angle in Degrees"
		self.alabel.pack(side=LEFT)
		self.aentry = Entry(self.xframe)
		self.aentry.pack(side=LEFT)
		self.aframe.pack()
		
		
		b = Button(root, text="Submit", width=10, command=self.callback)
		b.pack()
		
		root.mainloop()
	
	def createPolygon(self,x,y,angle):
		length = 10
		x0 = x + length * math.sin(math.radians(angle))
		y0 = y + length * math.cos(math.radians(angle))
		x1 = x + length * math.sin(math.radians(angle+120))
		y1 = y + length * math.cos(math.radians(angle+120))
		x2 = x + length * math.sin(math.radians(angle+240))
		y2 = y + length * math.cos(math.radians(angle+240))
		self.myPolygon = self.canvas.create_polygon((x0,y0,x1,y1,x2,y2),fill="blue")
	
	def movePolygon(self,x,y,angle):
		length = 10
		length1 = 20
		x0 = x + length1 * math.cos(math.radians(angle))
		y0 = y + length1 * math.sin(math.radians(angle))
		x1 = x + length * math.cos(math.radians(angle+120))
		y1 = y + length * math.sin(math.radians(angle+120))
		x2 = x + length * math.cos(math.radians(angle+240))
		y2 = y + length * math.sin(math.radians(angle+240))
		self.canvas.coords(self.myPolygon,x0,y0,x1,y1,x2,y2)
		
	def move(self,x,y,angle):
		self.canvas.create_line(self.linex,self.liney,x,y)
		self.linex = x
		self.liney = y
		self.movePolygon(self.linex,self.liney,angle)
	
	def callback(self):
		self.move(float(self.xentry.get()),float(self.yentry.get()),float(self.aentry.get()))

x = gui()
